{% macro delete_button(href, name) -%}
<!-- Button trigger modal -->
<button type="button" class="btn btn-sm btn-danger" data-toggle="modal" data-target="#delete{{name|hash}}Modal">
  Delete
</button>
<!-- Modal -->
<div class="modal fade" id="delete{{name|hash}}Modal" tabindex="-1" role="dialog" aria-labelledby="delete{{name|hash}}ModalLabel" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="delete{{name|hash}}ModalLabel">Delete <code>{{name}}</code>?</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        Are you sure you want to delete <code>{{name}}</code>?
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        <a href="{{href}}" class="btn btn-danger">Delete</a>
      </div>
    </div>
  </div>
</div>
{%- endmacro %}

{% macro table_row(key, value) -%}
<tr>
  <td>{{ key | replace('_', ' ') | title }}</td>
  <td>{{value}}</td>
</tr>
{%- endmacro %}

{% macro config_stats_table(config, stats) -%}
<div class="row">
  <div class="col-sm">
      <div class="table-responsive table-hover">
          <table class="table table-sm">
              <thead>
                <tr>
                  <th colspan="2" scope="col">Config</th>
                </tr>
              </thead>
            <tbody>
              {% for key in config if not key == 'type' %}
                {{table_row(key, config[key])}}
              {% endfor %}
            </tbody>
          </table>
        </div>
  </div>
  <div class="col-sm">
      {% if stats| length > 1 %} {# anything besides "type"? #}
      <div class="table-responsive table-hover">
        <table class="table table-sm">
          <thead>
            <tr>
              <th colspan="2" scope="col">Stats</th>
            </tr>
          </thead>
          <tbody>
            {% for key in stats if not key == 'type' %}
              {{table_row(key, stats[key])}}
            {% endfor %}
          </tbody>
        </table>
      </div>
      {% endif %}
  </div>
</div>
{%- endmacro %}

{% macro to_badge(item) -%}
{% set type = item["type"] or 'unknown' %}
{% set style = 'info' %}
{% if type in ['udp', 'score', 'score_auto', 'mpegts_h264'] %}
  {% set text = '{}: {}:{}'.format(type, item['ip'], item['port']) %}
{% elif type in ['tcp'] %}
  {% set text = '{}: {}:{}'.format(type, item['interface'], item['port']) %}
{% elif type in ['mp4_h264', 'mp4_aac'] %}
  {% set style = 'secondary' %}
  {% set text = '{}: {}'.format(type, item['file_path']) %}
{% elif type in ['cam_h264'] %}
    {% set style = 'dark' %}
    {% set text = '{}: {}'.format(type, item['camera_device']) %}
{% elif type in ['sdp_h264'] %}
    {% set style = 'light' %}
    {% set text = '{}: {}'.format(type, item['sdp_path']) %}
{% else %}
  {% set style = 'warning' %}
  {% set text = type %}
{% endif %}
<span class="badge badge-pill badge-{{style}}">{{text}}</span>
{%- endmacro %}